#
# Please see the COPYRIGHT_and_DISCLAIMER file in the top level
# directory of the distribution regarding the provisions under
# which this software is distributed.
#
sub error
{
    local(@args) = @_;
    local($error, @rest, $file, $line, $tree);

    $tree = shift(@args);

    if ($opt_v)
    {
	&backtrace;
    }

    if ($tree =~ /^\d+$/)
    {
	$error = shift(@args);
	@rest = @args;
	&tree_line_info($tree, $file, $line);
	$id = "$file:$line: ";
    }
    elsif ($tree ne '')
    {
	$error = $tree;
	$tree = '';
	@rest = @args;
	$id = '';
    }
    else
    {
	$error = shift(@args);
	$tree = '';
	@rest = @args;
	$id = '';
    }

#    print "tree='$tree' error='$error' rest='@rest'\n";

    warn "Error: $id$error\n";
    
    for (@rest)
    {
	warn "      $_\n";
    }

    $errors++;
}

sub fatal
{
    local($tree, $error, $file, $line, $id);
    local($i) = 1;
    local(@a);
    local($pkg,$file,$line,$subr,$h,$w);

    $tree = shift(@_);
    if ($tree =~ /^\d+$/)
    {
	$error = shift(@_);
	@rest = @_;
	&tree_line_info($tree, $file, $line);
	$id = "$file:$line: ";
    }
    elsif ($tree ne '')
    {
	$error = $tree;
	$tree = '';
	@rest = @_;
	$id = '';
    }
    else
    {
	$error = shift(@_);
	$tree = '';
	@rest = @_;
	$id = '';
    }
    
    warn "\nFatal error: $id$error\n";
    for (@rest)
    {
	warn "             $_\n";
    }

    exit(1) unless $opt_v;
    warn "Backtrace:\n";
    &backtrace;

    warn "Dumping state to cfcore\n";

    open(STDOUT, ">cfcore");
    &dump;
    
    exit 1;
}

sub backtrace
{
    local($i);
    $i = 1;
    while (1)
    {
	($pkg,$file,$line,$subr,$h,$w) = caller($i);
	@a = ($p,$f,$l,$s,$h,$w);

	last if !defined($pkg);
	warn " $subr: $file: $line\n";
	$i++;
    }
}

sub warning
{
    local($error, @rest, $id, $file, $line);

    $tree = shift(@_);
    if ($tree =~ /^\d+$/)
    {
	$error = shift(@_);
	@rest = @_;
	&tree_line_info($tree, $file, $line);
	$id = "$file:$line: ";
    }
    elsif ($tree ne '')
    {
	$error = $tree;
	$tree = '';
	@rest = @_;
	$id = '';
    }
    else
    {
	$error = shift(@_);
	$tree = '';
	@rest = @_;
	$id = '';
    }

    warn "Warning: $id$error\n";
    
    for (@rest)
    {
	warn "         $_\n";
    }
}

1;
	
