#
# Please see the COPYRIGHT_and_DISCLAIMER file in the top level
# directory of the distribution regarding the provisions under
# which this software is distributed.
#

sub generateDoLoops
{
    local($dim) = @_;
    local(@dims, @vars, $var);
    local($dos, $ends, $indent, $subscr, $pval, $lo, $hi);
    
    @dims = split(/\|/, $dim);

    for (@dims)
    {
	if ($_ eq "*")
	{
	    &fatal("* not allowed as an array dimension");
	}
	elsif (/^([^:]+):([^:]+)$/)
	{
	    $lo = $1;
	    $hi = $2;
	}
	else
	{
	    $lo = 1;
	    $hi = $_;
	}
	
	$var = &declareTemp('integer');
	push(@vars, $var);
	$dos .=  $indent . "do $var = $lo, $hi\n";
	$ends = $indent . "end do\n" . $ends;
	$indent .= "  ";
    }
    $subscr = join(", ", @vars);
    return($dos, $ends, $subscr, $indent);
}
	
	    
1;
