#!../Parser/fperl

#
# Please see the COPYRIGHT_and_DISCLAIMER file in the top level
# directory of the distribution regarding the provisions under
# which this software is distributed.
#
    
$show_parse_errors = 0;
$yydebug = 0;

require 'newgetopt.pl';

&NGetOpt("plain_common", "yydebug");

#print "ARGV = " . join(',',@ARGV), "\n";

while (@ARGV)
{
    push(@INC, shift(@ARGV));
}
	

require 'prim.ph';    
require 'tree.pl';
require 'error.pl';


$yydebug = $opt_yydebug ? 1 : 0;
$allow_plain_common = $opt_plain_common ? 1 : 0;

print "yydebug=$yydebug allow_plain_common=$allow_plain_common\n";

$| = 1;

#$rc = &parse("integer a\n", $t);

&set_input_file("stdin");

print "ftest> " if -t;
while (<>)
{
    $rc = &parse($_, $t, $it,  $., $failed_stmt);

    print "BEGIN line\n";
    print "rc=$rc t=$t it=$it failed_stmt=$failed_stmt\n";

    &dump($t,' ','bk00');

    if ($t && &tree_type_name($t) eq "block_if")
    {
	$str = &expr_to_string(&tree_kid($t, 0));
	print "Got str '$str'\n";
    }
    print "END line\n";
}
continue
{
    print "ftest> " if -t;
}

sub dump_parse_tree
{
    &dump;
}

sub dump
{
    local($t, $indent,$block) = @_;
    local($type, $name, $file, $line);
    local($nkids, $i, $kid);


    if ($t == 0)
    {
	print $indent . "NULL\n";
	return;
    }

    $type = &tree_type($t);
    $name = &tree_type_name($t);
    &tree_line_info($t, $file, $line);

    $nkids = &tree_num_kids($t);

    print $indent . "$name/$nkids at $file:$line";

#    print " has type $type $name and $nkids kids\n";

    if ($name eq "type_stmt") {
	
    } elsif ($name eq "binary_op") {
	$str = &expr_to_string($t);
	print ": $str\n";
	last;
    } elsif ($name eq "string")
    {
	$str = &tree_string_value($t);
	print ": \"$str\"\n";
    }
    elsif ($name eq "int")
    {
	$str = &tree_int_value($t);
	print ": $str\n";
    }
    else
    {
	print "\n";
    }

#    $block++;
#    print "$indent", "BEGIN $block\n";
    for ($i = 0; $i < $nkids; $i++)
    {
	$kid = &tree_kid($t, $i);
	&dump($kid, $indent . "  ", $block);
    }
#    print "$indent", "END $block\n";
}

