/*
 * Please see the COPYRIGHT_and_DISCLAIMER file in the top level
 * directory of the distribution regarding the provisions under
 * which this software is distributed.
 */


%token<t> IN_PORT OUT_PORT INTENT_IN INTENT_OUT INTENT_INOUT 
%token<t> INTEGER REAL BYTE LOGICAL CHARACTER DOUBLE COMPLEX PRECISION
%token<t> EXTERNAL INTRINSIC
%token<t> STARSTAR SLASHSLASH
%token<t> INTEGER_VAL ID STRING_VAL SP_REAL_VAL DP_REAL_VAL
%token<t> CALL IF THEN ELSE ENDIF ENDDO
%token<t> FUNCTION PROGRAM SUBROUTINE PROCESS
%token<t> PROCESSES END_PROCESSES PROCESS_DO END_CHANNEL END_PROCESS_DO
%token<t> CHANNEL MERGER SEND RECV  LOCATION SUBMACHINE
%token<t> REL_LT REL_LE REL_GT REL_GE REL_EQ REL_NE LOG_TRUE LOG_FALSE REL_NOT
%token<t> LOG_AND LOG_OR LOG_EQV LOG_NEQV
%token<t> IMPLICIT PARAMETER COMMON DIMENSION EOL
%token<t> INCLUDE PROBE MOVE_PORT PROCESSORS

%type<t> logical_constant    

%type<i> opt_process

%type<t> subprogram_stmt function_type character_type
%type<t> parameter_stmt parameter_decls parameter_decl
%type<t> implicit_decl implicit_gut implicit_guts 
%type<t> implicit_letter implicit_letters
%type<t> subprogram_args
%type<t> include_file
%type<t> executable
%type<t> opt_step
%type<t> channel_stmt
%type<t> merger_stmt
%type<t> send_stmt
%type<t> recv_stmt
%type<t> control_pair control_item control_list control_list_guts
%type<t> block_if_stmt
%type<t> else_if_stmt
%type<t> else_stmt
%type<t> end_if_stmt end_do_stmt end_processdo_stmt
%type<t> call_stmt
%type<t> annotation
%type<t> call_args
%type<t> call_arg
%type<t> port_name
/*
%type<t> port_list
*/
%type<t> variable_list variable
%type<t> indices
%type<t> data_implied_do_list
%type<t> didl_1
%type<t> didl_range
%type<t> array_element_name
%type<t> expr_list
%type<t> opt_expr
%type<t> expr 
%type<t> substring_name
%type<t> substring_args
%type<t> declaration
%type<t> dimension_stmt
%type<t> intrinsic_stmt
%type<t> common_stmt common_name
%type<t> common_guts opt_common_guts
%type<t> external_stmt
%type<t> type_stmt
%type<t> numeric_type
/*
%type<t> char_name_list
%type<t> char_name
*/
%type<t> opt_len_specification
%type<t> len_specification
%type<t> port_declaration
%type<t> port_decl_head
%type<t> intent_declaration
%type<t> machine_declaration
%type<t> name_list
%type<t> name
%type<t> data_type
%type<t> data_type_list
%type<t> fortran_data_type
%type<t> bounds
%type<t> bounds_elt
%type<t> dim_bound_expr
%type<t> dim_bound_const
%type<t> array_declarator array_declarator_list
%type<t> id_list

%left LOG_EQV LOG_NEQV
%left LOG_OR
%left LOG_AND
%nonassoc REL_LT REL_LE REL_GT REL_GE REL_EQ REL_NE 
%left SLASHSLASH
%left '+' '-'
%left '*' '/'
%right STARSTAR
%nonassoc UMINUS


%{
#include "symbol_redefines.h"

extern void yyerror();
extern int yylex();



#ifdef NeXT
#include <libc.h>
#endif

#include "tree.h"
#include "prim.h"

#ifndef NULL
#define NULL (void *) 0
#endif

extern tree_node *parse_tree;
extern int parse_type;

extern int allow_plain_common;

int current_control_type;

extern tree_node *gen_control_pair();
extern tree_node *grok_control_list();
%}

%union{
    tree_node *t;
    enum prim p;
    enum constant c;
    int i;
}

%%

line		: { current_control_type = -1; } line_guts

line_guts		:	item EOL
		|	error EOL 
		    {
			parse_tree = NULL;
		    }

		;

item		:	declaration 
		    {
			parse_type = PT_DECLARATION;
			parse_tree = $1;
		    }
		|	executable 
		    {
			parse_type = PT_EXECUTABLE;
			parse_tree = $1;
		    }
		|	subprogram_stmt
		    {
			parse_type = PT_SUBPROGRAM;
			parse_tree = $1;
		    }
		|	INCLUDE include_file
		    {
			parse_type = PT_INCLUDE;
			parse_tree = new_nodev(TREE_INCLUDE, 1, $2);
		    }
		;

include_file	:	ID
		|	STRING_VAL
		;

subprogram_stmt	:	PROGRAM ID subprogram_args
		    {
			$$ = new_nodev(TREE_PROGRAM, 2, $2, $3);
		    }
		|	function_type FUNCTION ID subprogram_args
		    {
			$$ = new_nodev(TREE_FUNCTION, 3, $3, $4, $1);
		    }
		|	SUBROUTINE ID subprogram_args
		    {
			$$ = new_nodev(TREE_SUBROUTINE, 2, $2, $3);
		    }
		|	PROCESS ID subprogram_args
		    {
			$$ = new_nodev(TREE_PROCESS, 2, $2, $3);
		    }
		;

subprogram_args	:	'(' id_list ')' 
		    {
			$$ = $2;
		    }
		|	/* empty */
		    {
			$$ = new_nodev(TREE_INTERNAL, 0);
		    }
		|	'(' ')'
		    {
			$$ = new_nodev(TREE_INTERNAL, 0);
		    }
		;

function_type	:	/* empty */
		    {
			$$ = new_nodev(TREE_TYPE, 0);
		    }
		|	numeric_type
		|	CHARACTER opt_len_specification
		;

executable	:	channel_stmt
		|	merger_stmt
		|	send_stmt
		|	recv_stmt
		|	call_stmt
		|	END_CHANNEL '(' 
				{ current_control_type = TREE_CHANNEL_CLOSE; }
			control_list ')'
		    {
			$$ = new_nodev(TREE_CHANNEL_CLOSE, 1, $4);
		    }
		|	PROBE '(' 
		    		{ current_control_type = TREE_PROBE; }
			control_list ')'
		    {
			$$ = new_nodev(TREE_PROBE, 1, $4);
		    }
		|	MOVE_PORT '(' 
				{ current_control_type = TREE_MOVE_PORT; }
			control_list ')'
		    {
			$$ = new_nodev(TREE_MOVE_PORT, 1, $4);
		    }
		|	PROCESSES
		    {
			$$ = new_nodev(TREE_PAR, 0);
		    }
		|	END_PROCESSES
		    {
			$$ = new_nodev(TREE_ENDPAR, 0);
		    }
		|	PROCESS_DO ID '=' expr ',' expr opt_step
		    {
			$$ = new_nodev(TREE_PARDO, 4, $2, $4, $6, $7);
		    }
		|	PROCESS_DO INTEGER_VAL ID '=' expr ',' expr opt_step
		    {
			$$ = new_nodev(TREE_LABELLED_PARDO, 5,
				       $3, $5, $7, $8, $2);
		    }
		|	block_if_stmt
		|	else_if_stmt
		|	else_stmt
		|	end_if_stmt
		|	end_do_stmt
		|	end_processdo_stmt
		;	

opt_step	:	/* empty */
		    {
			$$ = new_int_node(1);
		    }
		|	',' expr
		    {
			$$ = $2;
		    }
		;

channel_stmt	:	CHANNEL '('  
				{ current_control_type = TREE_CHANNEL; }
			control_list ')'
		    {
			$$ = new_nodev(TREE_CHANNEL, 1, $4);
		    }
		;		

merger_stmt	:	MERGER '(' 
				{ current_control_type = TREE_MERGER; }
			control_list ')'
		    {
			$$ = new_nodev(TREE_MERGER, 1, $4);
		    }
		;		

send_stmt	:	SEND '(' 
				{ current_control_type = TREE_SEND; }
			control_list ')' call_args
		    {
			$$ = new_nodev(TREE_SEND, 2, $4, $6);
		    }
		;

recv_stmt	:	RECV '(' 
				{ current_control_type = TREE_RECV; }
			control_list ')' variable_list
		    {
			$$ = new_nodev(TREE_RECV, 2, $4, $6);
		    }
		;

control_list	:	control_list_guts
		    {
			$$ = grok_control_list(current_control_type, $1);
		    }
		;

control_list_guts:	control_item
		    {
			$$ = new_nodev(TREE_INTERNAL, 1, $1);
		    }
    		|	control_list_guts ',' control_item
		    {
			$$ = add_kid($1, $3);
		    }
    		;

control_item	:	port_name
		|	control_pair
		|	data_implied_do_list
		;

control_pair	:	ID '=' port_name
		    {
			$$ = gen_control_pair(current_control_type,$1,$3);
		    }
		|	ID '=' INTEGER_VAL
		    {
			$$ = gen_control_pair(current_control_type,$1,$3);
		    }
		|	ID '=' data_implied_do_list
		    {
			$$ = gen_control_pair(current_control_type,$1,$3);
		    }
		;

block_if_stmt	:	IF '(' expr ')' THEN
		    {
			$$ = new_nodev(TREE_BLOCK_IF, 1, $3);
		    }
		;

else_if_stmt	:	ELSE IF '(' expr ')' THEN
		    {
			$$ = new_nodev(TREE_ELSE_IF, 1, $4);
		    }
		;

else_stmt	:	ELSE
		    {
			$$ = new_nodev(TREE_ELSE, 0);
		    }
		;

end_if_stmt	:	ENDIF
		    {
			$$ = new_nodev(TREE_ENDIF, 0);
		    }
		;
end_do_stmt	:	ENDDO
		    {
			$$ = new_nodev(TREE_ENDDO, 0);
		    }
		;
end_processdo_stmt	:	END_PROCESS_DO
		    {
			$$ = new_nodev(TREE_ENDPARDO, 0);
		    }
		;
call_stmt	:	PROCESS CALL ID annotation
		    {
			$$ = new_nodev(TREE_CALL, 4,
				       new_int_node(1),
				       $3,
				       new_nodev(TREE_INTERNAL, 0),
				       $4);
		    }
		|	PROCESS CALL ID '(' ')' annotation
		    {
			$$ = new_nodev(TREE_CALL, 4,
				       new_int_node(1),
				       $3,
				       new_nodev(TREE_INTERNAL, 0),
				       $6);
		    }
		|	PROCESS CALL ID '(' call_args ')' annotation
		    {
			$$ = new_nodev(TREE_CALL, 4,
				       new_int_node(1),
				       $3,
				       $5,
				       $7);
		    }
		|	call_head ID '(' call_args ')' error_annotation
		    {
			$$ = new_nodev(TREE_CALL, 4,
				       new_int_node(0),
				       $2,
				       $4,
				       new_nil_node());
		    }
		|	call_head ID '(' ')' error_annotation
		    {
			$$ = new_nodev(TREE_CALL, 4,
				       new_int_node(0),
				       $2,
				       new_nodev(TREE_INTERNAL, 0),
				       new_nil_node());
		    }
		|	call_head ID error_annotation
		    {
			$$ = new_nodev(TREE_CALL, 4,
				       new_int_node(0),
				       $2,
				       new_nodev(TREE_INTERNAL, 0),
				       new_nil_node());
		    }
		;

call_head	:	CALL 
		    {
			current_control_type = TREE_CALL;
		    }
		;

annotation	:	/* empty */
		    {
			$$ = new_nil_node();
		    }
		|	LOCATION '(' indices ')'
		    {
			$$ = new_nodev(TREE_LOCATION, 1, $3);
		    }
		|	SUBMACHINE '(' indices ')'
		    {
			$$ = new_nodev(TREE_SUBMACHINE, 1, $3);
		    }
		;

error_annotation:	/* empty */
		|	LOCATION '(' indices ')'
		    {
                        printf("Annotations are not allowed on plain calls. Use PROCESS CALL instead\n");			
			YYERROR;
		    }
		|	SUBMACHINE '(' indices ')'
		    {
                        printf("Annotations are not allowed on plain calls. Use PROCESS CALL instead\n");			
			YYERROR;
		    }
		;

call_args	:	call_arg
		    {
			$$ = new_nodev(TREE_INTERNAL, 1, $1);
		    }
		|	call_args ',' call_arg
		    {
			$$ = add_kid($1, $3);
		    }
		;

call_arg	:	expr
		|	'*' INTEGER_VAL
		    {
			printf("Labels as call arguments not supported\n");
			$$ = NULL;
		    }
		;

port_name	:	ID
		|	array_element_name
		;

/*
port_list	:	port_name
		    {
			$$ = new_nodev(TREE_INTERNAL, 1, $1);
		    }
		|	data_implied_do_list
		    {
			$$ = new_nodev(TREE_INTERNAL, 1, $1);
		    }
		|	port_list ',' port_name
		    {
			$$ = add_kid($1, $3);
		    }
		;
*/

variable	:	ID
		|	array_element_name
		;

variable_list	:	variable
		    {
			$$ = new_nodev(TREE_INTERNAL, 1, $1);
		    }
		|	variable_list ',' variable
		    {
			$$ = add_kid($1, $3);
		    }
		;

indices		:	expr_list
		;

data_implied_do_list:	'(' didl_1 ',' ID '=' didl_range ')'
		    {
			$$ = new_nodev(TREE_DO_LIST, 3,
				       $2, $4, $6);
/*			$$ = unwind_didl($$);*/
		    }
		;

didl_1		:	array_element_name
		    {
			$$ = new_nodev(TREE_INTERNAL, 1, $1);
		    }
		|	data_implied_do_list
		    {
			$$ = new_nodev(TREE_INTERNAL, 1, $1);
		    }
		|	didl_1 ',' array_element_name 
		    {
			$$ = add_kid($1, $3);
		    }
		|	didl_1 ',' data_implied_do_list 
		    {
			$$ = add_kid($1, $3);
		    }
		;

didl_range	:	expr
		    {
			$$ = new_nodev(TREE_RANGE, 1, $1);
		    }
		|	expr ',' expr
		    {
			$$ = new_nodev(TREE_RANGE, 2, $1, $3);
		    }
		|	expr ',' expr ',' expr
		    {
			$$ = new_nodev(TREE_RANGE, 3, $1, $3, $5);
		    }
		;

array_element_name:	ID '(' expr_list ')'
		    {
			$$ = new_nodev(TREE_ARRAY_ELEMENT_NAME,
				       2, $1, $3);
		    }
		;

expr_list	:	expr
		    {
			$$ = new_nodev(TREE_INTERNAL, 1, $1);
		    }
		|	expr_list ',' expr
		    {
			$$ = add_kid($1, $3);
		    }
		;

opt_expr	:	expr
		|	/* empty */
		    {
			$$ = new_nil_node();
		    }
		;

expr		:	ID
		|	INTEGER_VAL
		|	STRING_VAL
		    {
			$$ = new_nodev(TREE_STRING_CONST, 1, $1);
		    }
		|	SP_REAL_VAL
		|	DP_REAL_VAL
		|	substring_name
		|	logical_constant
		|	array_element_name
		|	'(' expr ')'
		    {
			$$ = new_nodev(TREE_UNARY_OP, 2,
				       new_int_node(OP_PAREN),
				       $2);
		    }
		|	expr '+' expr
		    {
			$$ = new_nodev(TREE_BINARY_OP, 3,
				       new_int_node(OP_PLUS),
				       $1, $3);
		    }
		|	expr '-' expr
		    {
			$$ = new_nodev(TREE_BINARY_OP, 3,
				       new_int_node(OP_MINUS),
				       $1, $3);
		    }
		|	expr '*' expr
		    {
			$$ = new_nodev(TREE_BINARY_OP, 3,
				       new_int_node(OP_MUL),
				       $1, $3);
		    }
		|	expr '/' expr
		    {
			$$ = new_nodev(TREE_BINARY_OP, 3,
				       new_int_node(OP_DIV),
				       $1, $3);
		    }
		|	expr STARSTAR expr
		    {
			$$ = new_nodev(TREE_BINARY_OP, 3,
				       new_int_node(OP_POW),
				       $1, $3);
		    }
		|	expr SLASHSLASH expr
		    {
			$$ = new_nodev(TREE_BINARY_OP, 3,
				       new_int_node(OP_CONCAT),
				       $1, $3);
		    }
		|	expr REL_LT expr
		    {
			$$ = new_nodev(TREE_BINARY_OP, 3,
				       new_int_node(OP_LT),
				       $1, $3);
		    }
		|	expr REL_LE expr
		    {
			$$ = new_nodev(TREE_BINARY_OP, 3,
				       new_int_node(OP_LE),
				       $1, $3);
		    }
		|	expr REL_GT expr
		    {
			$$ = new_nodev(TREE_BINARY_OP, 3,
				       new_int_node(OP_GT),
				       $1, $3);
		    }
		|	expr REL_GE expr
		    {
			$$ = new_nodev(TREE_BINARY_OP, 3,
				       new_int_node(OP_GE),
				       $1, $3);
		    }
		|	expr REL_NE expr
		    {
			$$ = new_nodev(TREE_BINARY_OP, 3,
				       new_int_node(OP_NE),
				       $1, $3);
		    }
		|	expr REL_EQ expr
		    {
			$$ = new_nodev(TREE_BINARY_OP, 3,
				       new_int_node(OP_EQ),
				       $1, $3);
		    }
		|	expr LOG_AND expr
		    {
			$$ = new_nodev(TREE_BINARY_OP, 3,
				       new_int_node(OP_AND),
				       $1, $3);
		    }
		|	expr LOG_OR expr
		    {
			$$ = new_nodev(TREE_BINARY_OP, 3,
				       new_int_node(OP_OR),
				       $1, $3);
		    }
		|	expr LOG_EQV expr
		    {
			$$ = new_nodev(TREE_BINARY_OP, 3,
				       new_int_node(OP_EQV),
				       $1, $3);
		    }
		|	expr LOG_NEQV expr
		    {
			$$ = new_nodev(TREE_BINARY_OP, 3,
				       new_int_node(OP_NEQV),
				       $1, $3);
		    }
		|	REL_NOT expr %prec UMINUS
		    {
			$$ = new_nodev(TREE_UNARY_OP, 2,
				       new_int_node(OP_NOT),
				       $2);
		    }
		|	'+' expr %prec UMINUS
		    {
			$$ = new_nodev(TREE_UNARY_OP, 2,
				       new_int_node(OP_PLUS),
				       $2);
		    }
		|	'-' expr %prec UMINUS
		    {
			$$ = new_nodev(TREE_UNARY_OP, 2,
				       new_int_node(OP_MINUS),
				       $2);
		    }
		;

substring_name	:	ID substring_args
		    {
			$$ = new_nodev(TREE_SUBSTRING, 2, $1, $2);
		    }
		|	array_element_name substring_args
		    {
			$$ = new_nodev(TREE_SUBSTRING, 2, $1, $2);
		    }
		;

substring_args	:	'(' opt_expr ':' opt_expr ')'
		    {
			$$ = new_nodev(TREE_INTERNAL, 2, $2, $4);
		    }
		;

declaration	:	port_declaration
		|	intent_declaration
		|	machine_declaration
		|	implicit_decl
		|	parameter_stmt
		|	type_stmt
		|	dimension_stmt
		|	common_stmt
		|	intrinsic_stmt
		|	external_stmt
		;

implicit_decl	:	IMPLICIT implicit_guts
		    {
			$$ = map_list_0(TREE_IMPLICIT, $2);
		    }
		|	IMPLICIT ID
		    {
			if (strcasecmp($2->data.sdata, "none") == 0)
			{
			    $$ = new_nodev(TREE_INTERNAL, 1,
					   new_nodev(TREE_IMPLICIT, 0));
			}
			else
			{
			    YYERROR;
			}
			    
		    }
						     
				
		;

implicit_guts	:	implicit_gut
		    {
			$$ = new_nodev(TREE_INTERNAL, 1, $1);
		    }
		|	implicit_guts ',' implicit_gut
		    {
			$$ = add_kid($1, $3);
		    }
		;

implicit_gut	:	numeric_type '(' implicit_letters ')'
		    {
			$$ = new_nodev(TREE_INTERNAL, 2, $1, $3);
		    }
		|	CHARACTER opt_len_specification '(' implicit_letters ')'
		    {
			$$ = new_nodev(TREE_INTERNAL, 2,
				       new_nodev(TREE_TYPE, 2,
						 new_string_node("character"),
						 $2),
				       $4);
		    }
		;

implicit_letters:	implicit_letter
		    {
			$$ = new_nodev(TREE_INTERNAL, 1, $1);
		    }
		|	implicit_letters ',' implicit_letter
		    {
			$$ = add_kid($1, $3);
		    }
		;
		
implicit_letter	:	ID
		    {
			char *buf = (char *)
			    malloc(strlen($1->data.sdata) * 2 + 2);
			strcpy(buf, $1->data.sdata);
			strcat(buf, "-");
			strcat(buf, $1->data.sdata);
			$$ = new_string_node(buf);
		    }
		|	ID '-' ID
		    {
			char *buf = (char *)
			    malloc(strlen($1->data.sdata) +
				   strlen($3->data.sdata) + 2);
			strcpy(buf, $1->data.sdata);
			strcat(buf, "-");
			strcat(buf, $3->data.sdata);
			$$ = new_string_node(buf);
		    }
		;
			

parameter_stmt	:	PARAMETER 
		    {
		    }	
			'(' parameter_decls ')'
		    {
			$$ = map_list_0(TREE_PARAMETER, $4);
		    }
		;

parameter_decls	:	parameter_decl
		    {
			$$ = new_nodev(TREE_INTERNAL, 1, $1);
		    }
		|	parameter_decls ',' parameter_decl
		    {
			$$ = add_kid($1, $3);
		    }
		;

parameter_decl	:	ID '=' expr
		    {
			$$ = new_nodev(TREE_INTERNAL, 2, $1, $3);
		    }
		;

dimension_stmt:		DIMENSION array_declarator_list
		    {
			$$ = map_list_0(TREE_DIMENSION, $2);
		    }
		;

intrinsic_stmt:		INTRINSIC id_list
		    {
			$$ = map_list_0(TREE_INTRINSIC, $2);
		    }
		;

opt_process	:	/* empty */ 
		    {
			$$ = 0;
		    }
		|	PROCESS
		    {
			$$ = 1;
		    }
		;

common_stmt	:	opt_process COMMON name_list opt_common_guts
		    {
			int i;
			tree_node *this_one;

			if ($1 == 0 && !allow_plain_common)
			{
			    fatal("COMMON is not allowed in Fortran M. Use PROCESS COMMON intead\n");
			}

			this_one = new_nodev(TREE_COMMON, 2,
					     new_nodev(TREE_COMMON_BLANK, 0),
					     $3);

			if ($4 == NULL)
			{
			    $$ = new_nodev(TREE_INTERNAL, 1, this_one);
			}
			else
			{
			    $$ = add_kid_to_front($4, this_one);
			}
		    }
		|	opt_process COMMON common_guts
		    {
			if ($1 == 0 && !allow_plain_common)
			{
			    fatal("COMMON is not allowed in Fortran M. Use PROCESS COMMON intead\n");
			}

			$$ = $3;
		    }
/*
		|	COMMON name_list opt_common_guts
		    {
			fatal("COMMON is not allowed in Fortran-M. Use PROCESS COMMON intead\n");
		    }
		|	COMMON common_guts
		    {
			fatal("COMMON is not allowed in Fortran-M. Use PROCESS COMMON intead\n");
		    }
*/
		;

opt_common_guts	:	/* empty */
		    {
			$$ = NULL;
		    }
		|	opt_comma common_guts
		    {
			$$ = $2;
		    }
		;

common_name	:	'/' '/'
		    {
			$$ = new_nodev(TREE_COMMON_BLANK, 0);
		    }
		|	SLASHSLASH
		    {
			$$ = new_nodev(TREE_COMMON_BLANK, 0);
		    }
		|	'/' ID '/'
		    {
			$$ = $2;
		    }
		;

common_guts	:	common_name name_list opt_comma common_guts 
		    {
			tree_node *com = new_nodev(TREE_COMMON, 2,
						   $1, $2);

			$$ = add_kid_to_front($4, com);
		    }
		|	common_name name_list
		    {
			$$ = new_nodev(TREE_INTERNAL, 1,
				       new_nodev(TREE_COMMON, 2, $1, $2));
		    }
		;
			
external_stmt:	EXTERNAL id_list
		    {
			$$ = map_list_0(TREE_EXTERNAL, $2);
		    }
		;
		
type_stmt	:	fortran_data_type name_list
		    {
			$$ = map_list_1(TREE_TYPE_STMT, $1, $2);
		    }
		;

fortran_data_type:	numeric_type
		|	character_type
		;

character_type	:	CHARACTER
		    {
			$$ = new_nodev(TREE_TYPE, 1,
				       new_string_node("character*1"));
		    }
		|	CHARACTER '*' INTEGER_VAL
		    {
			char buf[100];
			sprintf(buf, "character*%d", $3->data.idata);
			$$ = new_nodev(TREE_TYPE, 1, new_string_node(buf));
		    }
			
		|	CHARACTER '*' '(' '*' ')'
		    {
			$$ = new_nodev(TREE_TYPE, 1, new_string_node("character*(*)"));
		    }
		|	CHARACTER '*' '(' expr ')'
		    {
			char buf[100];
			sprintf(buf, "character*EXPR(%d)", $4);
			$$ = new_nodev(TREE_TYPE, 1, new_string_node(buf));
		    }
			
		;

numeric_type	:	INTEGER
		    {
			tree_node *kid = new_string_node("integer");
			$$ = new_nodev(TREE_TYPE, 1, kid);
		    }
		|	REAL
		    {
			$$ = new_nodev(TREE_TYPE, 1,
				       new_string_node("real"));
		    }
		|	BYTE
		    {
			$$ = new_nodev(TREE_TYPE, 1,
				       new_string_node("byte"));
		    }
		|	LOGICAL
		    {
			$$ = new_nodev(TREE_TYPE, 1,
				       new_string_node("logical"));
		    }
		|	DOUBLE PRECISION
		    {
			$$ = new_nodev(TREE_TYPE, 1,
				       new_string_node("doubleprecision"));
		    }
		|	COMPLEX
		    {
			$$ = new_nodev(TREE_TYPE, 1,
				       new_string_node("complex"));
		    }
		|	DOUBLE COMPLEX
		    {
			$$ = new_nodev(TREE_TYPE, 1,
				       new_string_node("doublecomplex"));
		    }
		;

opt_comma	:	','
		|	/* empty */
		;

/*
char_name_list	:	char_name
		    {
			$$ = new_nodev(TREE_INTERNAL, 1, $1);
		    }
		|	char_name_list ',' char_name
		    {
			$$ = add_kid($1, $3);
		    }
		;

char_name	:	ID opt_len_specification
		;
*/

opt_len_specification:	'*' len_specification
		    {
			$$ = $2;
		    }
		|	/* empty */
		    {
			$$ = new_nil_node();
		    }
		;

len_specification:	'(' '*' ')'
		    {
			$$ = new_string_node("*");
		    }
		|	INTEGER_VAL
		|	'(' expr ')'
		    {
			$$ = $2;
		    }
		;

port_declaration:	port_decl_head name_list
		    {
			$$ = map_list_1(TREE_TYPE_STMT,
					$1, $2);
		    }
		;

port_decl_head	:	IN_PORT commit_inport '(' data_type_list ')'
		    {
			$$ = new_nodev(TREE_IN_PORT, 1, $4);
		    }
		|	IN_PORT commit_inport fortran_data_type
		    {
			$$ = new_nodev(TREE_IN_PORT, 1,
				       new_nodev(TREE_INTERNAL, 1, $3));
		    }
		|	OUT_PORT commit_outport '(' data_type_list ')'
		    {
			$$ = new_nodev(TREE_OUT_PORT, 1, $4);
		    }
		|	OUT_PORT commit_outport fortran_data_type
		    {
			$$ = new_nodev(TREE_OUT_PORT, 1,
				       new_nodev(TREE_INTERNAL, 1, $3));
		    }
		;

commit_inport	:   /* empty */
		    {
			current_control_type = TREE_IN_PORT;
		    }
		;

commit_outport	:   /* empty */
		    {
			current_control_type = TREE_OUT_PORT;
		    }
		;

commit_intent	:   /* empty */
		    {
			current_control_type = TREE_INTENT;
		    }
		;

data_type	:	fortran_data_type 
		|	fortran_data_type name
		    {
			$$ = new_nodev(TREE_DUMMY_TYPE, 2, $1, $2);
		    }
		|	port_decl_head
		|	port_decl_head name
		    {
			$$ = new_nodev(TREE_DUMMY_TYPE, 2, $1, $2);
		    }
		;

data_type_list	:	data_type 
		    {
			$$ = new_nodev(TREE_INTERNAL, 1, $1);
		    }
		|	data_type_list ',' data_type
		    {
			$$ = add_kid($1, $3);
		    }
		;

intent_declaration:	INTENT_IN commit_intent name_list
		    {
			$$ = map_list_1(TREE_INTENT,
					new_string_node("in"),
					$3);
		    }
		|	INTENT_OUT commit_intent name_list
		    {
			$$ = map_list_1(TREE_INTENT,
					new_string_node("out"),
					$3);
		    }
		|	INTENT_INOUT commit_intent name_list
		    {
			$$ = map_list_1(TREE_INTENT,
					new_string_node("inout"),
					$3);
		    }
		;

machine_declaration:	PROCESSORS '(' bounds ')'
		    {
			$$ = new_nodev(TREE_INTERNAL, 1,
				       new_nodev(TREE_MACHINE_STMT, 1, $3));
		    }
		;

name_list	:	name
		    {
			$$ = new_nodev(TREE_INTERNAL, 1, $1);
		    }
		|	name_list ',' name
		    {
			$$ = add_kid($1, $3);
		    }
		;

name		:	ID
		    {
			$$ = new_nodev(TREE_NAME, 1, $1);
		    }
		|	array_declarator
		    {
			$$ = new_nodev(TREE_NAME, 1, $1);
		    }
		;


/*
 * $$ = node(TREE_BOUNDS, low, high)
 * or   node(TREE_BOUNDDS, size)
 *
 */
bounds		:	bounds_elt
		    {
			$$ = new_nodev(TREE_BOUNDS, 1, $1);
		    }
		|	bounds ',' bounds_elt
		    {
			$$ = add_kid($1, $3);
		    }
		;

bounds_elt	:	dim_bound_expr
		|	dim_bound_expr ':' dim_bound_expr
		    {
			$$ = new_nodev(TREE_LOWER_UPPER, 2, $1, $3);
		    }
		;

dim_bound_expr	:	dim_bound_const 
		|	'+' dim_bound_const %prec UMINUS
		    {
			$$ = new_nodev(TREE_UNARY_OP, 3,
				       new_int_node(OP_PLUS),
				       $2);
		    }
		|	'-' dim_bound_const %prec UMINUS
		    {
			$$ = new_nodev(TREE_UNARY_OP, 2,
				       new_int_node(OP_MINUS),
				       $2);
		    }
    		|	dim_bound_expr '+' dim_bound_expr
		    {
			$$ = new_nodev(TREE_BINARY_OP, 3,
				       new_int_node(OP_PLUS),
				       $1, $3);
		    }
    		|	dim_bound_expr '-' dim_bound_expr
		    {
			$$ = new_nodev(TREE_BINARY_OP, 3,
				       new_int_node(OP_MINUS),
				       $1, $3);
		    }
    		|	dim_bound_expr '*' dim_bound_expr
		    {
			$$ = new_nodev(TREE_BINARY_OP, 3,
				       new_int_node(OP_MUL),
				       $1, $3);
		    }
    		|	dim_bound_expr '/' dim_bound_expr
		    {
			$$ = new_nodev(TREE_BINARY_OP, 3,
				       new_int_node(OP_DIV),
				       $1, $3);
		    }
    		|	dim_bound_expr STARSTAR dim_bound_expr
		    {
			$$ = new_nodev(TREE_BINARY_OP, 3,
				       new_int_node(OP_POW),
				       $1, $3);
		    }
		|	'*'
		    {
			$$ = new_string_node("*");
		    }
		;

dim_bound_const	:	INTEGER_VAL
		|	ID
		| 	'(' dim_bound_expr ')'
		    {
			$$ = $2;
		    }
		;


logical_constant:	LOG_TRUE
		    {
			$$ = new_nodev(TREE_LOGICAL, 1,
				       new_string_node(".TRUE."));
		    }
		|	LOG_FALSE
		    {
			$$ = new_nodev(TREE_LOGICAL, 1,
				       new_string_node(".FALSE."));
		    }
		;

array_declarator:	ID '(' bounds ')'
		    {
			$$ = new_nodev(TREE_ARRAY_DECLARATOR,
				       2,
				       $1,
				       $3);
		    }
		;

array_declarator_list:	array_declarator
		    {
			$$ = new_nodev(TREE_INTERNAL, 1, $1);
		    }
		|   array_declarator_list ',' array_declarator
		    {
			$$ = add_kid($1, $3);
		    }
		;

id_list		:	ID
		    {
			$$ = new_nodev(TREE_INTERNAL, 1, $1);
		    }
		|	id_list ',' ID
		    {
			$$ = add_kid($1, $3);
		    }
		;
		    
